<?php
require_once( 'wp-load.php' );
function my_scope() {
  global $wpdb, $current_user;
	$prefix = esc_sql( $wpdb->prefix );

  // ユーザー定義のユーザーロールspecialを追加する
  add_role( 'special', 'Special' );

  // ロールオブジェクトを取得する
  $role = get_role( 'special' );

  // specialロールに権限を追加する
  $role->add_cap( 'read' );
  print_r( $role );

  // specialロールの権限をwp_optionsテーブルから確認する
  $ret = get_option( $prefix . 'user_roles' );
  print_r( $ret['special'] );

  // 新しいユーザーを作成する
  $args = array(
    'user_login'    => 'test',
    'user_pass'     => 'password',
    'user_nicename' => 'test',
    'user_url'      => 'test',
    'user_email'    => 'test@example.com',
    'display_name'  => 'test',
    'nickname'      => 'test',
    'first_name'    => 'test',
    'last_name'     => 'test',
    'description'   => 'test',
    'rich_editing'  => 'true',
    'user_registered' => gmdate('Y-m-d H:i:s'),
    'role'          => 'subscriber',
    'comment_shortcuts' => 'true',
    'admin_color'   => 'fresh',
    'use_ssl'       => '0',
    'show_admin_bar_front' => 'true',
  );

  $ret = wp_insert_user( $args );
  var_dump($ret);

  // ログイン名でユーザーを取得する
  $user = get_user_by( 'login', 'test' );

  // ユーザーのロールを変更する
  $user->set_role( 'special' );

  // ユーザーロールの変更がwp_usermetaテーブルに反映したことを確認する
  $ret = $wpdb->get_results(
    $wpdb->prepare( "
      SELECT *
      FROM $wpdb->usermeta
      WHERE user_id = %d AND meta_key = %s
    ", $user->ID, $prefix . 'capabilities' )
  );
  var_dump($ret);

  // ユーザー情報を更新するための準備
  $user->user_url   = 'url2';
  $user->first_name = 'first';
  $user->last_name  = 'last';

  // ユーザー情報を更新する
  wp_update_user( $user );

  // ユーザー情報にメタ情報を追加する
  add_user_meta( $user->ID, 'sample_key', 'sample_value' );

  // ユーザー情報の更新がデータベースに反映したことを確認する
  $ret = $wpdb->get_results(
    $wpdb->prepare( "
      SELECT user_url
      FROM $wpdb->users
      WHERE ID = %d
    ", $user->ID )
  );
  var_dump($ret);

  $ret = $wpdb->get_results(
    $wpdb->prepare( "
      SELECT *
      FROM $wpdb->usermeta
      WHERE user_id = %d AND meta_key IN ( 'first_name', 'last_name', 'sample_key' )
    ", $user->ID )
  );
  var_dump($ret);

  // 現在のユーザーを変更する
  var_dump( is_user_logged_in(), current_user_can( 'special' ), $current_user->ID );

  wp_set_current_user( $user->ID );

  var_dump( is_user_logged_in(), current_user_can( 'special' ), $current_user->ID );

  // ユーザーを削除する
  require_once( ABSPATH . 'wp-admin/includes/user.php' );
  wp_delete_user( $user->ID );

  // specialロールを削除する
  remove_role( 'special' );

}
my_scope();

